<template>
  <div class="sign-up-section">
    <div class="wrap-content position-relative py-5">
      <img
        src="@/assets/img/game_overlay.png"
        class="position-absolute top-0 start-0 w-100"
        style="height: 100%; object-fit: cover; z-index: -1;"
      />
      <div class="content-section container">
        <div class="row justify-content-center">
          <div class="col col-11 col-lg-7">
            <div class="form-wrap py-4 py-lg-5 px-4 px-lg-5">
              <h2 class="text-danger fw-bold text-center mb-3 mb-lg-5">Sign Up</h2>
              <div class="d-flex align-items-center mb-4">
                <i class="far fa-envelope text-danger" style="font-size: 32px;"></i>
                <input
                  type="email"
                  class="form-control form-control-lg border-danger border-2 ms-2"
                  id="username"
                  placeholder="name@example.com"
                  v-model="emailUser"
                />
              </div>
              <div class="d-flex align-items-center mb-4">
                <i class="fas fa-lock text-danger" style="font-size: 32px;"></i>
                <input
                  type="password"
                  class="form-control form-control-lg border-2 border-danger ms-2"
                  id="password"
                  placeholder="Password"
                  v-model="pwdUser"
                />
              </div>
              <div class="d-flex align-items-center mb-4">
                <i class="fas fa-lock text-danger" style="font-size: 32px;"></i>
                <input
                  type="password"
                  class="form-control form-control-lg border-2 border-danger ms-2"
                  id="cf-password"
                  placeholder="Confirm password"
                  v-model="confirmPwdUser"
                />
              </div>
              <div class="d-flex align-items-center mb-4">
                <i class="fas fa-user text-danger" style="font-size: 32px;"></i>
                <input
                  type="text"
                  class="form-control form-control-lg border-2 border-danger ms-2"
                  id="name"
                  placeholder="Enter your name"
                  v-model="nameUser"
                />
              </div>
              <div class="d-flex align-items-center mb-4">
                <i class="fas fa-user text-danger" style="font-size: 32px;"></i>
                <input
                  type="text"
                  class="form-control form-control-lg border-2 border-danger ms-2"
                  id="userid"
                  placeholder="Referral id user"
                  v-model="referralIdUser"
                />
              </div>
              <div class="d-flex align-items-center mb-4">
                <select
                  class="form-select border-2 border-danger"
                  id="country-id"
                  aria-label="Country"
                  v-model="countryId"
                >
                  <option v-for="(item, ind) in listCountry" :key="ind" :value="item.id">
                    {{ item.name }}
                  </option>
                </select>
              </div>
              <div class="d-flex justify-content-end mt-4">
                <div class="remember-me">
                  <input class="form-check-input" type="checkbox" value="" id="rememberme" v-model="rememberMe" />
                  <label class="form-check-label ms-2" for="rememberme" style="opacity: .7">
                    Remember me
                  </label>
                </div>
              </div>
              <div class="d-flex justify-content-center mb-3 mt-3 mt-lg-5 brand-img">
                <!-- <img src="@/assets/img/ic_fb.png" style="width: 60px; cursor: pointer" @click="fbSignUp" /> -->
                <!-- <img src="@/assets/img/ic_google.png" style="width: 60px; cursor: pointer" />
                <img src="@/assets/img/ic_apple.png" style="width: 60px; cursor: pointer" />
                <img src="@/assets/img/ic_talk.png" style="width: 60px; cursor: pointer" /> -->
              </div>
              <div class="d-flex justify-content-center pt-4">
                <button
                  class="btn btn-danger rounded-pill px-5 py-1 px-lg-5 py-lg-2"
                  style="font-size: 22px;"
                  @click="signUp"
                >
                  Sign Up
                </button>
              </div>
              <p
                class="text-end text-danger mt-2"
                style="font-size: 18px; cursor: pointer"
                @click="$router.push('/signin').catch(() => {})"
              >
                Sign In
                <i class="fas fa-chevron-right ms-2"></i>
              </p>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { apiCustomerPost, apiCustomerGet } from "../services/baseApi.js";
import { fbAuth } from "../services/authSocial.js";
import sweetAlert from "../helper/sweetAlert.js";

export default {
  data() {
    return {
      nameUser: "",
      emailUser: "",
      pwdUser: "",
      confirmPwdUser: "",
      referralIdUser: "",
      countryId: 245,
      rememberMe: true,
      listCountry: []
    };
  },
  methods: {
    validateEmail(mail) {
      if (/^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/.test(mail)) {
        return true;
      }
      return false;
    },
    async signUp() {
      try {
        if (!this.nameUser || !this.emailUser || !this.pwdUser || !this.confirmPwdUser || !this.countryId) {
          sweetAlert.toastAlert(this, "error", "Please enter all required information");
          return;
        }

        if (this.pwdUser !== this.confirmPwdUser) {
          sweetAlert.toastAlert(this, "error", "Your password and confirmation password do not match");
          return;
        }

        if (!this.validateEmail(this.emailUser)) {
          sweetAlert.toastAlert(this, "error", "You have entered an invalid email address");
          return;
        }

        let body = {
          name: this.nameUser,
          email: this.emailUser,
          password: this.pwdUser,
          countryId: this.countryId,
          userId: this.referralIdUser || ""
        };

        let res = await apiCustomerPost("auth/register", body);

        if (res && res.data && res.data.status && res.data.data) {
          localStorage.removeItem("user");
          localStorage.removeItem("token");

          sweetAlert.toastAlert(this, "success", "Your Signup has success");
          this.$router.push("/signin").catch(() => {});
        }
      } catch (error) {
        console.log("sign up erro:", error.response);
        sweetAlert.toastAlert(this, "error", error.response.data.message);
      }
    },
    async getListCountry() {
      try {
        let res = await apiCustomerGet("country");
        if (res && res.data && res.data.data) {
          this.listCountry = res.data.data.flat();
        }
      } catch (error) {
        console.log("get list country error:", error);
      }
    },
    fbSignUp() {
      fbAuth(this);
    }
  },
  mounted() {
    this.getListCountry();
  }
};
</script>

<style scoped>
.wrap-content {
  min-height: 100vh;
}
.form-wrap {
  background: #fff;
  border-radius: 32px;
}
#username,
#cf-password,
#name,
#userid,
#country-id,
#password {
  border-top: none;
  border-left: none;
  border-right: none;
  border-radius: 0;
}

@media screen and (max-width: 991px) {
  i {
    font-size: 22px !important;
  }
  .brand-img img {
    width: 42px !important;
  }
  .remember-me label {
    font-size: 14px !important;
  }
}
</style>
